#!/bin/bash

if [ "$FROM_YAML" = "yes" ]; then
	COVERALLS="--coveralls-id=$TRAVIS_JOB_ID"
else
	unset COVERALLS
fi

CURDIR="$(pwd)"

rm -rf kcov-user
mkdir -p kcov-user /tmp/kcov-root
./tests/scripts/prepare_test_environment
kcov --exclude-path=${CURDIR}/tests,${CURDIR}/tmp,/usr/lib,/etc --exclude-pattern=msmtpq-ng.rc,.msmtpq-ng.rc,msmtpq-ng-mta.rc,fakeroot-sysv,fake-flock,lock-fail --bash-handle-sh-invocation ${CURDIR}/kcov-user ./tests/scripts/run_all_tests
KUSR="$USER"
KGRP="$(id -gn "$KUSR")"
rm -rf kcov-all
mkdir -p kcov-all
rm -rf kcov-sendmail
rm -rf kcov-root
cp -r /tmp/kcov-root ${CURDIR}/
sudo cp -r /tmp/kcov-sendmail ${CURDIR}/
sudo chown -R "$KUSR":"$KGRP" ${CURDIR}/kcov-sendmail
kcov --merge $COVERALLS ${CURDIR}/kcov-all ${CURDIR}/kcov-user ${CURDIR}/kcov-sendmail ${CURDIR}/kcov-root
